unit Player;

interface

uses MapData, Winapi.Windows, Communication;

type
  TPlayer = class
    protected
      FMapData: TMapData;
    public
      constructor Create(MD: TMapData);
      destructor Destroy; override;

      procedure HandleKey(Key: Word); virtual;
      procedure OnUpdate; virtual;
  end;

implementation

constructor TPlayer.Create(MD: TMapData);
begin
  FMapData := MD;
end;

destructor TPlayer.Destroy;
begin
end;

procedure TPlayer.HandleKey(Key: Word);
var x, y: Integer;
begin
  x := FMapData.Comm.Player.X;
  y := FMapData.Comm.Player.Y;

  if Key = Word('W') then
  begin
    if FMapData.CanMoveToPosition(x, y - 1) then
    begin
      FMapData.Move(cdUp);
    end;
  end else
  if Key = Word('S') then
  begin
    if FMapData.CanMoveToPosition(x, y + 1) then
    begin
      FMapData.Move(cdDown);
    end;
  end else
  if Key = Word('A') then
  begin
    if FMapData.CanMoveToPosition(x - 1, y) then
    begin
      FMapData.Move(cdLeft);
    end;
  end else
  if Key = Word('D') then
  begin
    if FMapData.CanMoveToPosition(x + 1, y) then
    begin
      FMapData.Move(cdRight);
    end;
  end;
end;

procedure TPlayer.OnUpdate;
begin
end;

end.
