unit Renderer;

interface

uses Vcl.Graphics, Winapi.Windows;

type
  TRenderer = class
    private
      FCanvas: TCanvas;
      FWidth: Integer;
      FHeight: Integer;
    public
      ClearColor: TColor;

      constructor Create(Canvas: TCanvas);
      destructor Destroy; override;

      procedure ClearScreen;
      procedure SetViewportSize(W, H: Integer);

      procedure RenderQuadText(X, Y, W, H: Integer; Text: string; Color: TColor);

      property Canvas: TCanvas read FCanvas;
  end;

implementation

constructor TRenderer.Create(Canvas: TCanvas);
begin
  FCanvas := Canvas;
  ClearColor := clWhite;
  FCanvas.Font.Color := clWhite;
end;

destructor TRenderer.Destroy;
begin
end;

procedure TRenderer.ClearScreen;
var rect: TRect;
begin
  rect.Top := 0;
  rect.Left := 0;
  rect.Width := FWidth;
  rect.Height := FHeight;
  FCanvas.Brush.Color := ClearColor;
  FCanvas.FillRect(rect);
end;

procedure TRenderer.SetViewportSize(W: Integer; H: Integer);
begin
  FWidth := W;
  FHeight := H;
end;

procedure TRenderer.RenderQuadText(X: Integer; Y: Integer; W: Integer; H: Integer; Text: string; Color: TColor);
var rect: TRect;
begin
  FCanvas.Brush.Color := Color;
  rect.Top := Y;
  rect.Left := X;
  rect.Width := W;
  rect.Height := H;

  FCanvas.FillRect(rect);
  FCanvas.TextOut(X + W div 2 - FCanvas.TextWidth(Text) div 2, Y + H div 2 - FCanvas.TextHeight(Text) div 2, Text);
end;

end.
